/* 
   This code implements a lagrange interpolation polynomial.  The input is an
   index to a point (x,y) at which a 5 point interpolation will be centered 
   around.  The output is the maximum of the interpolation to the nearest 
   tenth of a Hz within 5 Hz of the input point.
   11/17/96  Modified so that it returns a type NOTE that has the 
             magnitude and freq fields set to the interpolated maximum 
             magnitude and corresponding frequency. 

   11/26/96  Modified the way we find the max interpolated point.  We
             were finding the first max and assuming that was it.  In
             testing, there appears to be more than one max, so we have
             to search all the values and keep the max of the maxes.  
             Still didn't work for trp_1_~G4~.5th.dat.  There is an
             outrageous magnitude getting in for some reason.  Put in
             a hack to only check P[20] through P[80].  Need to really
	     fix this.
   11/27/96  I fixed the above mentioned bug.  I wasn't initializing
             the array P[100].  Data was continuously accumulating
             in this array.  Some problems also went away when 
             I did a make clean and recompiled everything.  
*/

#include "note.h"
#include <stdio.h>

NOTE lgrng(int index){
  // variable declaration & initialization
double L[5][100]=
{{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
 {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
 {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
 {1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1}};
double P[100]; /* holds interpolation results */
float* lx; /* x values from fft array */
float* ly; /* y values from fft array */
float f[100];  /* interpolation points */
int i,       /* counters */
    j,
    k;
extern float frequency[];
extern float magnitude[];
NOTE lg_note; /* note structure to return with freq and mag. field set */
// begin code
// first set up pointers to correct locations
// and interpolation points

for(i=0;i<100;i++)
{
   P[i]=0.0;
}
lx = &frequency[index-2];
ly = &magnitude[index-2];
f[0]=frequency[index]-5;
for (i=1;i<100;i++){
   f[i] = f[i-1]+0.1;
}
for (k = 0;k<=99;k++){
  for (i = 0;i<=4;i++){
    for (j = 0;j<=4;j++){
      if (j != i){
         L[i][k]=L[i][k]*(f[k]-lx[j])/(lx[i]-lx[j]);
      } /* end if */
    } /*end for */
    P[k] = P[k]+(ly[i]*L[i][k]);
  } /* end for */
} /* end for */

// find max interpolation point

i = 0;
while(P[i]<P[i+1])
   i++;
/**************** changed ***********  
i_max = 0;
for(i=0;i<100;i++)
{
if(P[i]>P[i_max])
      i_max = i;
}
************************************/
lg_note.freq = f[i];
lg_note.magnitude = P[i];
return(lg_note);
}
