typedef struct note{
   float freq;
   float magnitude;
   int overtone;
   char name[4];
   int code;
   int quality;
   struct note *next_note;
}NOTE;

typedef struct note_trait{
   float freq;
   char name[4];
   int code;
   float max_freq;
   float min_freq;
   int left;
   int right;
}NOTE_TRAIT;

#define pi 3.14159265359
#define N 1024
 
#define NUM_NOTES 60
#define TRUE 1
#define FALSE 0
#define FACTOR 0.0594631 /* 12 root 2 minus 1 */
#define FACTOR_INV 0.0561257 /* 1 - 1/12 root 2 */
#define IN_TUNE_TOLERANCE 5
#define IN_TUNE 0
/* 
#define FLAT_TOLERANCE -.15
#define FLAT -1
#define VERY_FLAT -2
#define SHARP_TOLERANCE .15
#define SHARP 1
#define VERY_SHARP 2
*/

#define MAX 2563.0
#define CORRECTED_MAX 2450 /* when we have to correct a note by increasing it, the maximum we can handle before correction is less than MAX */
#define CORRECT_02 0.0189
#define CORRECT_04 -0.1329 
#define CORRECT_05 0.0189
#define CORRECT_06 -0.3005 
#define CORRECT_08 0.0380
#define CORRECT_09 -0.1327
#define CORRECT_10 -0.4666
#define CORRECT_11 0.0190
