/********************************************************/
/*							*/
/*	Name:  Sifter.cc				*/
/*							*/
/*  This program finds the peaks from fft data, 	*/
/*  passes the info to an interpolation program		*/
/*  then classifies the peaks if they are musical	*/
/*  notes.						*/
/*	                                                */
/*  11/28/96  WCM--added a line to set the value of  	*/
/*            temp->next_note to NULL.  This seems to   */
/*            keep the program from crashing, at least  */
/*            on the file tru_1_~B4~.raw which is the   */
/*            only file that I know of that causes a    */
/*            crash.                                    */
/********************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "note.h"

NOTE lgrng(int);

NOTE* sifter()
{

	extern float magnitude[1024];
	NOTE* note_list;
	NOTE* temp;
	NOTE* current;
	NOTE* endptr;
	int i=2;
	int points=509;
	int check=0;	
	int max_overtones=11;
	int subtractor=0;	
	int req_overtones=2;
	float multiple=0;
	float lowthreshold=0.03;
	float hithreshold=0.97;
	float normal=0.0;
	float snr=0.15;	
	float min_mag=100000;
	float max_mag=0.0;
	float min_freq=80.1;
	float max_freq=2563.0;
		
	/* initialize variables*/
	note_list=NULL;
	temp=NULL;
	current=NULL;
        endptr=NULL;
		
	/*find the peaks in the spectrum*/
	/*and place them in a note list*/

	while(i<points)
	{
		if(magnitude[i]<magnitude[i+1])
			i++;
		else if(magnitude[i]<min_mag)
		        i++;

		else
		{
			temp=(NOTE*)malloc(sizeof(NOTE));
			temp=&lgrng(i);
			/*WCM ADDED CODE */
			temp->next_note = NULL;
			/* end WCM ADDED CODE */
    	
			if(temp->magnitude>max_mag)
			{
				max_mag=temp->magnitude;
			}
			
			current=note_list;	
			if(note_list!=NULL)
			{
				while(current!=NULL)
				{
					multiple=(temp->freq)/(current->freq);
					subtractor=(int)multiple;
					multiple=multiple-(float)subtractor;
	
					if(subtractor>11)
					{
						current=current->next_note;
					}	
					else if(multiple<lowthreshold)
					{
						
						current[subtractor-1]= *temp;
						free(temp);
						current[0].overtone++;
				 
						current=temp=NULL;
					}
					else if(multiple>hithreshold)
					{
						current[subtractor]= *temp;
						free(temp);
					
						current[0].overtone++;
						current=temp=NULL;
					}
					else
						current=current->next_note;
				}
				if(temp!=NULL)
				{
					endptr->next_note=(NOTE*)calloc(max_overtones+1,sizeof(NOTE));
					endptr=endptr->next_note;
					endptr[0]=*temp;
					free(temp);
					temp=NULL;
				}
			}
			else if(note_list==NULL)
			{
				note_list=(NOTE*)calloc(max_overtones+1,sizeof(NOTE));	
				note_list[0]=*temp;
                                free(temp);
				endptr=note_list;
				current = note_list;
			}
			/* find a minimum */
			while(magnitude[i]>magnitude[i+1])
			{
			i++;
			}	

		}
	}

	/* identify notes and throw away extraneous peaks */

	
	if(note_list!=NULL)
	{
		current=note_list->next_note;
		temp=note_list;

		/* check first note in the note list */
	
		
		check=0;
		while(check==0)
		{	
			normal=(temp->magnitude)/(max_mag);
	
			if((temp->freq<min_freq)||(temp->freq>max_freq))
			{
				note_list=current;
				free(temp);
				temp=current;
				current=current->next_note;
			}

			else if((temp->overtone<req_overtones)&&(normal<snr))
			{
				note_list=current;
				free(temp);
				temp=current;
				current=current->next_note;
			}
			else
			{
				check++;
			}	
		}		
	
		/*check the other possible notes in the note list*/

		while(current!=NULL)
		{
			normal=0.0;
	
			normal=(current->magnitude)/(max_mag);
			if((current->freq<min_freq)||(current->freq>max_freq))
			{

				temp->next_note=current->next_note;
				free(current);
				current=temp->next_note;
			}	
			else if((current->overtone<req_overtones)&&(normal<snr))
			{
			        temp->next_note=current->next_note;
				free(current);
				current=temp->next_note;
			}
			else
			{
				current=current->next_note;
				temp=temp->next_note;
			}		
		}
		
	}
	
	return(note_list);

}
