
#include "callbacks.h"
#include "gui.h"

XSegment segs[13];

void OptionsCB(Widget menu_item, int item_num, 
               XmAnyCallbackStruct *cbs)
{
  switch (item_num)
    {
      case 0: TunerCB(); 
              break; 
      case 1: IntervalCB();
              break;
      case 2: exit();
              break;
    }
}


void TunerCB()
{
  extern Widget *current_form;
  extern Widget tuner_form;
  extern Widget toplevel;

  XtUnmanageChild(*current_form);
  XtDestroyWidget(tuner_form);
  MakeTunerForm();
  XtManageChild(tuner_form);
  *current_form = tuner_form;
  
  DrawTunerStaff();

}


void IntervalCB()
{
  extern Widget *current_form;
  extern Widget interval_form;
  extern Widget toplevel;

  XtUnmanageChild(*current_form);
  XtDestroyWidget(interval_form);
  MakeIntervalForm();
  XtManageChild(interval_form);
  *current_form = interval_form;

  DrawIntervalStaff();

}



void TuneCB()
{
  extern Widget *current_button;
  extern Widget tune_button;
  extern Widget stop_button;
  extern Widget note_field;
  extern Widget tune_slider;
  extern Widget tuner_draw_area;
  extern GC tuner_gc;


  XtUnmanageChild(*current_button);
  XtDestroyWidget(tune_button);
  MakeStopButton(); 
  
/*****EXAMPLES****/
  XmTextSetString(note_field, "AA");
  XmScaleSetValue(tune_slider, 25);

  /****************************
    PUT CODE HERE FOR AFTER THE
  "TUNE" BUTTON HAS BEEN PRESSED
  *****************************/

}



void StopCB()
{
  extern Widget *current_button;
  extern Widget stop_button; 
  extern Widget tune_button;
  extern Widget note_field;
  extern Widget tune_slider;

  XtUnmanageChild(*current_button);
  XtDestroyWidget(stop_button);
  MakeTuneButton();

  /****************************
    PUT CODE HERE FOR AFTER THE
  "STOP" BUTTON HAS BEEN PRESSED
  *****************************/
}






void NextIntervalCB()
{
   extern Widget interval_field;

  /*  ?  */
}

void RecordCB()
{
  extern Widget *current_button2;
  extern Widget record_button;
  extern Widget stop_record_button;

  XtUnmanageChild(*current_button2);
  XtDestroyWidget(record_button);
  MakeStopRecordButton();
 
  /****************************
    PUT CODE HERE FOR AFTER THE
  "RECORD" BUTTON HAS BEEN PRESSED
  *****************************/

}



void StopRecordCB()
{
  extern Widget *current_button2;
  extern Widget stop_record_button;

  XtUnmanageChild(*current_button2);
  XtDestroyWidget(stop_record_button);
  MakeRecordButton();

  /****************************
    PUT CODE HERE FOR AFTER THE
  "STOP RECORD" BUTTON HAS BEEN PRESSED
  *****************************/
}



void ClearStaffCB()
{
  DrawIntervalStaff();
}


void LoadSegments()
{
   segs[0].x1 = 61; segs[0].y1 = 71; segs[0].x2 = 61; segs[0].y2 = 222;
   segs[1].x1 = 231; segs[1].y1 = 71; segs[1].x2 = 231; segs[1].y2 = 222;
   segs[2].x1 = 61; segs[2].y1 = 71; segs[2].x2 = 231; segs[2].y2 = 71;
   segs[3].x1 = 61; segs[3].y1 = 83; segs[3].x2 = 231; segs[3].y2 = 83;
   segs[4].x1 = 61; segs[4].y1 = 95; segs[4].x2 = 231; segs[4].y2 = 95;
   segs[5].x1 = 61; segs[5].y1 = 107; segs[5].x2 = 231; segs[5].y2 = 107;
   segs[6].x1 = 61; segs[6].y1 = 119; segs[6].x2 = 231; segs[6].y2 = 119;
   segs[7].x1 = 61; segs[7].y1 = 172; segs[7].x2 = 231; segs[7].y2 = 172;
   segs[8].x1 = 61; segs[8].y1 = 184; segs[8].x2 = 231; segs[8].y2 = 184;
   segs[9].x1 = 61; segs[9].y1 = 196; segs[9].x2 = 231; segs[9].y2 = 196;
   segs[10].x1 = 61; segs[10].y1 = 208; segs[10].x2 = 231; segs[10].y2 = 208;
   segs[11].x1 = 61; segs[11].y1 = 220; segs[11].x2 = 231; segs[11].y2 = 220;
}


void DrawTunerStaff()
{
   extern Widget tuner_draw_area;
   extern GC tuner_gc;

   XDrawSegments(XtDisplay(tuner_draw_area), XtWindow(tuner_draw_area),
		tuner_gc, segs, 12);   
}


void DrawIntervalStaff()
{
   extern Widget interval_draw_area;
   extern GC interval_gc;

   XDrawSegments(XtDisplay(interval_draw_area), XtWindow(interval_draw_area),
                interval_gc, segs, 12);

}

