/* gui.c */

#include "gui.h"
#define SLIDER_MIN -50
#define SLIDER_MAX 50

XtAppContext app;

Widget  toplevel;
Widget  main_form;
Widget  *current_form;
Widget  menu_bar;
Widget  tuner_form;
Widget  interval_form;
Widget  dummy_form;
Widget  *current_button;
Widget  tune_button;
Widget  stop_button;
Widget  *current_button2;
Widget  record_button;
Widget  stop_record_button;
Widget  tune_slider;
Widget  note_field;
Widget  interval_field;
Widget  tuner_draw_area;
Widget  interval_draw_area;
GC      tuner_gc;
GC      interval_gc;

void MakeGui(argc,argv)
int argc;
char *argv[];
{ 
  current_form = (Widget *)malloc(sizeof(Widget));
  toplevel = XtVaAppInitialize(&app, "SWCTUNE",  0, 0,
               &argc, argv, NULL, NULL);

  XtVaSetValues(toplevel, XmNtitle, "SWC-TUNE", NULL);
  main_form = XtVaCreateManagedWidget("main_form",xmFormWidgetClass,toplevel, 
                XtNwidth, 280,
                XtNheight, 460,
                XmNrubberPositioning, TRUE,
                XmNnoResize, TRUE,
                NULL);

/*  Menu Bar  */
  {
    XmString Options = XmStringCreateSimple("Options");

    menu_bar = XmVaCreateSimpleMenuBar(main_form, "menu_bar",
                XmVaCASCADEBUTTON, Options, 'O', 
		XmNtopAttachment, XmATTACH_FORM,
                XmNleftAttachment, XmATTACH_FORM,
                XmNrubberPositioning, FALSE,
                NULL);
    XmStringFree(Options);
  }

/* pull-downs for menu_bar */
  {
    XmString Tuner = XmStringCreateSimple("Tuner");
    XmString IntDet = XmStringCreateSimple("Interval Detect");
    XmString Quit = XmStringCreateSimple("Quit");
  
    XmVaCreateSimplePulldownMenu(menu_bar, "options_menu",0,OptionsCB,
                 XmVaPUSHBUTTON, Tuner, 'T', NULL, NULL,
                 XmVaPUSHBUTTON, IntDet, 'I', NULL, NULL,
                 XmVaPUSHBUTTON, Quit, 'Q', NULL, NULL);

    XmStringFree (Tuner);
    XmStringFree (IntDet);
    XmStringFree (Quit);
   }

  XtManageChild(menu_bar);
  dummy_form = XtVaCreateManagedWidget("dummy_form", xmFormWidgetClass, toplevel, NULL);
  *current_form = dummy_form;

}

void MakeTunerForm()
{
   Widget flat_label;
   Widget intune_label;
   Widget sharp_label;
   Widget note_name_label;
   Widget draw_form;
   

  tuner_form = XtVaCreateWidget("tuner_widget", xmFormWidgetClass,
                  main_form, NULL); 

  XtVaSetValues(tuner_form,
                 XmNtopAttachment, XmATTACH_WIDGET,
                 XmNbottomAttachment, XmATTACH_POSITION,
                 XmNleftAttachment, XmATTACH_POSITION,
                 XmNrightAttachment, XmATTACH_POSITION,
                 XmNtopWidget, menu_bar,
                 XmNbottomPosition, 100,
                 XmNleftPosition, 0,
                 XmNrightPosition, 100, 
                 NULL);

  tune_slider = XtVaCreateManagedWidget("tune_slider",
		xmScaleWidgetClass, tuner_form,
		XtVaTypedArg, XmNtitleString, XmRString,
                "<--------------flat   ||   sharp------------->", 47,
 		XmNmaximum, SLIDER_MAX,
		XmNminimum, SLIDER_MIN,
		XmNvalue, 0,
		XmNorientation, XmHORIZONTAL,
		NULL);

  XtVaSetValues(tune_slider,
		XmNtopAttachment,XmATTACH_FORM,
		XmNbottomAttachment, XmATTACH_POSITION,
		XmNleftAttachment, XmATTACH_POSITION,
		XmNrightAttachment, XmATTACH_POSITION,
		XmNbottomPosition, 10,
		XmNleftPosition, 0,
		XmNrightPosition, 100, 
		NULL);
 
/*   draw_form = XtVaCreateManagedWidget("draw_form",xmFormWidgetClass,tuner_form,
                XtNwidth, 280,
                XtNheight, 280,  
                NULL);
*/
  tuner_draw_area = XtVaCreateManagedWidget("tuner_draw_area",
		xmDrawingAreaWidgetClass, tuner_form,NULL);

  XtVaSetValues(tuner_draw_area,
		XtNwidth, 280,
                XtNheight, 280,
		XmNtopAttachment,XmATTACH_POSITION,
 		XmNleftAttachment, XmATTACH_POSITION,
		XmNrightAttachment, XmATTACH_POSITION,
		XmNtopPosition, 10,
/*		XmNtopWidget, tune_slider,
*/
		XmNleftPosition, 0,
                XmNrightPosition, 100,
		NULL);
  {
  XmString NoteLabel = XmStringCreateSimple("Note Name: ");
  note_name_label = XtVaCreateManagedWidget("note_name_label",
		xmLabelWidgetClass, tuner_form,
		XmNlabelString, NoteLabel,
		NULL); 
  XtVaSetValues(note_name_label,
  		XmNtopAttachment,XmATTACH_WIDGET,
		XmNleftAttachment, XmATTACH_POSITION,
                XmNtopWidget, tuner_draw_area,
                XmNleftPosition, 10,
                NULL);

  XmStringFree(NoteLabel); 
  }

  note_field = XtVaCreateManagedWidget("note_field", xmTextFieldWidgetClass,
		tuner_form, NULL);
  XtVaSetValues(note_field,
		XmNtopAttachment,XmATTACH_WIDGET,
                XmNleftAttachment, XmATTACH_WIDGET,
                XmNrightAttachment, XmATTACH_POSITION,
                XmNtopWidget, tuner_draw_area,
                XmNleftWidget, note_name_label,
                XmNrightPosition, 90,
                NULL);

   MakeTuneButton(); 
   SetupTunerGC();

}

void MakeTuneButton()
{
   tune_button = XtVaCreateWidget("Tune", xmPushButtonWidgetClass,
		tuner_form, NULL);

   XtVaSetValues(tune_button, 
		XmNtopAttachment, XmATTACH_POSITION,
		XmNleftAttachment, XmATTACH_POSITION,
		XmNtopPosition, 90,
		XmNleftPosition, 40,
		NULL);
   XtAddCallback(tune_button, XmNactivateCallback, TuneCB, NULL);
   XtManageChild(tune_button);
   current_button = (Widget *)malloc(sizeof(Widget));
   *current_button = tune_button;
}


void MakeStopButton()
{
   stop_button = XtVaCreateWidget("Stop", xmPushButtonWidgetClass,
                tuner_form, NULL);

   XtVaSetValues(stop_button, 
                XmNtopAttachment, XmATTACH_POSITION,
                XmNleftAttachment, XmATTACH_POSITION,
                XmNtopPosition, 90,
                XmNleftPosition, 40,
                NULL);
   XtAddCallback(stop_button, XmNactivateCallback, StopCB, NULL);
   XtManageChild(stop_button);
   *current_button = stop_button;
}

void MakeIntervalForm()
{
   Widget draw_form;
   Widget interval_label;
   Widget next_interval_button;
   Widget record_button;
   Widget clear_staff_button;


  interval_form = XtVaCreateWidget("interval_form", xmFormWidgetClass,
                  main_form, NULL); 

  XtVaSetValues(interval_form,
                 XmNtopAttachment, XmATTACH_WIDGET,
                 XmNbottomAttachment, XmATTACH_POSITION,
                 XmNleftAttachment, XmATTACH_POSITION,
                 XmNrightAttachment, XmATTACH_POSITION,
                 XmNtopWidget, menu_bar,
                 XmNbottomPosition, 100,
                 XmNleftPosition, 0,
                 XmNrightPosition, 100, 
                 NULL);

  interval_draw_area = XtVaCreateManagedWidget("draw_area",
                xmDrawingAreaWidgetClass, interval_form,NULL);

  XtVaSetValues(interval_draw_area,
                XtNwidth, 280,
                XtNheight, 280,
                XmNtopAttachment,XmATTACH_POSITION,
                XmNleftAttachment, XmATTACH_POSITION,
                XmNrightAttachment, XmATTACH_POSITION,
                XmNtopPosition, 5,
                XmNleftPosition, 0,
                XmNrightPosition, 100,
                NULL);
   
  {
  XmString IntervalLabel = XmStringCreateSimple("Interval");
  interval_label = XtVaCreateManagedWidget("interval_label",
                xmLabelWidgetClass, interval_form,
                XmNlabelString, IntervalLabel,
                NULL); 

   XtVaSetValues(interval_label,
                XmNtopAttachment,XmATTACH_WIDGET,
                XmNleftAttachment, XmATTACH_POSITION,
                XmNtopWidget, interval_draw_area,
                XmNleftPosition, 10,
                NULL);

   XmStringFree(IntervalLabel);
   }
  
   interval_field = XtVaCreateManagedWidget("interval_field", xmTextFieldWidgetClass,
                interval_form, NULL); 
   XtVaSetValues(interval_field,
                XmNtopAttachment,XmATTACH_WIDGET,
                XmNleftAttachment, XmATTACH_WIDGET,
                XmNrightAttachment, XmATTACH_POSITION,
                XmNtopWidget, interval_draw_area,
                XmNleftWidget, interval_label,
                XmNrightPosition, 90,
                NULL);


   next_interval_button = XtVaCreateManagedWidget("Next Interval", xmPushButtonWidgetClass,
                interval_form, NULL);

   XtVaSetValues(next_interval_button, 
                XmNtopAttachment, XmATTACH_POSITION,
                XmNleftAttachment, XmATTACH_POSITION,
                XmNtopPosition, 82,
                XmNleftPosition, 20, 
                NULL);
   XtAddCallback(next_interval_button, XmNactivateCallback, NextIntervalCB, NULL);


   clear_staff_button = XtVaCreateManagedWidget("Clear Staff", xmPushButtonWidgetClass,
                interval_form, NULL);

   XtVaSetValues(clear_staff_button,
                XmNtopAttachment, XmATTACH_POSITION,
                XmNrightAttachment, XmATTACH_POSITION,
                XmNtopPosition, 90,
                XmNrightPosition, 95,
                NULL);
   XtAddCallback(clear_staff_button, XmNactivateCallback, ClearStaffCB, NULL);
   
   MakeRecordButton();
   SetupIntervalGC();

}

void MakeRecordButton()
{
   record_button = XtVaCreateWidget("Record", xmPushButtonWidgetClass,
                interval_form, NULL);

   XtVaSetValues(record_button,
                XmNtopAttachment, XmATTACH_POSITION,
                XmNleftAttachment, XmATTACH_POSITION,
                XmNtopPosition, 90,
                XmNleftPosition, 5,
                NULL);
   XtAddCallback(record_button, XmNactivateCallback, RecordCB, NULL);

   XtManageChild(record_button);
   current_button2 = (Widget *)malloc(sizeof(Widget));
   *current_button2 = record_button;
}



void MakeStopRecordButton()
{
   stop_record_button = XtVaCreateWidget("Stop", xmPushButtonWidgetClass,
                interval_form, NULL);

   XtVaSetValues(stop_record_button,
                XmNtopAttachment, XmATTACH_POSITION,
                XmNleftAttachment, XmATTACH_POSITION,
                XmNtopPosition, 90,
                XmNleftPosition, 5,
                NULL);
   XtAddCallback(stop_record_button, XmNactivateCallback, StopRecordCB, NULL);

   XtManageChild(stop_record_button);
   *current_button2 = stop_record_button;
}



void SetupTunerGC()
{
   int foreground, background;
   XGCValues vals;
   Arg al[10];
   int ac;
   
   ac = 0;
   XtSetArg(al[ac], XmNforeground, &foreground); ac++;
   XtSetArg(al[ac], XmNbackground, &background); ac++;
   XtGetValues(tuner_draw_area, al, ac);

   vals.foreground = foreground;
   vals.background = background;
   vals.line_width = 3;
   tuner_gc = XtGetGC(tuner_draw_area, GCForeground | GCBackground | GCLineWidth , &vals);

}

void SetupIntervalGC()
{
   int foreground, background;
   XGCValues vals;
   Arg al[10];
   int ac;

   ac = 0;
   XtSetArg(al[ac], XmNforeground, &foreground); ac++;
   XtSetArg(al[ac], XmNbackground, &background); ac++;
   XtGetValues(interval_draw_area, al, ac);

   vals.foreground = foreground;
   vals.background = background;
   vals.line_width = 3;
   interval_gc = XtGetGC(interval_draw_area, GCForeground | GCBackground | GCLineWidth , &vals);

}
