/*
This program generates a digitally sampled (at a given rate) sine wave and store
s it in the file sin.raw.
*/
 
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "struct.h"
 
void sine_wave(long int, SINUSOID *, float, int);
 
int main (int, char**) {
 
   int num;				/* number of sinusoids */
   int n;
   long int fs;				/* sample frequency in hertz */
   float sample;			/* length of the sample in seconds */
   SINUSOID *waves;			/* series of sinusoids */
   SINUSOID *current;			/* current sinusoid */
 
   waves=(SINUSOID *)malloc(sizeof(SINUSOID));
   current=waves;			/* set up current sinusoid */
   current->next_wave=NULL;		/* set end of list */

   system("clear");			/* clear the screen */

/* prompt the user for  the number of freqencies that make up the sample */

   num=0;
   while(num<=0){
      fprintf(stderr,"How many frequencies in sample (at least 1)?  ");
      scanf("%d",&num);
   }

   n=0;
   do{
      n++;
      fprintf(stderr,"\nWave #%d:\n",n);
      fprintf(stderr,"   Normalized amplitude (0 < A <= 1):  ");
      scanf("%f",&current->A);
      fprintf(stderr,"   Frequency in Hertz               :  ");
      scanf("%ld",&current->freq);
      fprintf(stderr,"   Phase shift in radians           :  ");
      scanf("%f",&current->phi);
      if(n!=num){
         current->next_wave=(SINUSOID *)malloc(sizeof(SINUSOID));
         current=current->next_wave;
         current->next_wave=NULL;
      }
   } while(n<num);

   fprintf(stderr,"\nEnter the sample frequency in Hertz :  ");
   scanf("%ld",&fs);
   fprintf(stderr,"Enter the sample length in seconds  :  ");
   scanf("%f",&sample);

   sine_wave(fs, waves, sample, num);

   return 0;
}

